AddDamageType("DeathPowerup", '%1 found the worst powerup!', '%1 found the worst powerup!', 1, 1);

function fxDtsBrick::LottoLoop(%brick)
{
	if(%brick.isFakeDead() || %brick.powerup !$= "???") return;
	cancel(%brick.LottoLoop);
	if(isObject(%emit = %brick.emitter))
		%emit.setColor(getRandom(0, 100) / 100 SPC getRandom(0, 100) / 100 SPC getRandom(0, 100) / 100 SPC 1);
	%brick.LottoLoop = %brick.schedule(16, "LottoLoop");
}

function Player::GetRandomPowerup(%pl, %start)
{
	if(!isObject(%cl = %pl.client) && %pl.getState() $= "DEAD") return;
	%time = vectorDist(%start, getSimTime()) / 3000;
	if(%time > 1)
	{
		%power[-1+%powers++] = "Blast 3 50";
		%power[-1+%powers++] = "Mine 1 30";
		%power[-1+%powers++] = "Jet 4 50";
		%power[-1+%powers++] = "Regen 3 100";
		%power[-1+%powers++] = "Blink 3 60";
		%power[-1+%powers++] = "Icy 1 25";
		%power[-1+%powers++] = "Sniper 2 60";
		%power[-1+%powers++] = "Death 0 20";
		%power[-1+%powers++] = "Blast! 1 1";
		%power[-1+%powers++] = "Mine! 1 1";
		%power[-1+%powers++] = "Blink! 1 1";
		for(%i=0;%i<%powers;%i++)
			%sum += getWord(%power[%i], 2);
		%value = getRandom(0, %sum - 1);
		for(%i=0;%i<%powers;%i++)
		{
			%data = %power[%i];
			%freq = getWord(%data, 2);
			if(%value >= %freq)
				%value -= %freq;
			else
			{
				%powerName = firstWord(%data);
				switch$(%powerName)
				{
					case "Death":
						%cl.centerPrint("<color:800000>DEATH\c6 powerup!<br>\c7Die without a saving throw. Man, this power sucks!", 5);
						%pl.schedule(3000, "damage", 0, %pl.getPosition(), 10000, $DamageType::DeathPowerup);
					default:
						if(%powerName@"!" $= %pl.currentPowerup)
							%pl.powerupCharge++;
						else
						{
							if(%powerName !$= %pl.currentPowerup)
								%pl.powerupCharge = 0;
							%pl.currentPowerup = %powerName;
							%pl.powerupCharge += getWord(%data, 1);
						}
						%cl.showPowerupInfo();
						%cl.showPowerupPrint();
				}
				return;
			}
		}
		return;
	}
	else
	{
		%cl.centerPrint("\c7???\c6 powerup!<br>\c7??????????", 3);
		%pl.schedule(100, "GetRandomPowerup", %start);
	}
}